/* Copyright (C) 1986-2001 by Digital Mars. $Revision: 1.1.1.1 $ */

extern (C)  int
	 disp_numrows,
	 disp_numcols,
	 disp_cursorrow,
	 disp_cursorcol;
extern (C) short disp_nowrap;  /* does display wrap or not */	

extern (C)  int	 disp_printf(char *,...);
extern (C)  int	 disp_getmode();
extern (C)  int	 disp_getattr();
extern (C)  int	 disp_putc(int);
extern (C)  void	 disp_levelblockpoke(int,int,int,int,uint,uint *,uint,uint *,uint);
extern (C)  void	 disp_open();
extern (C)  void	 disp_puts(char *);
extern (C)  void	 disp_box(int,int,uint,uint,uint,uint);
extern (C)  void	 disp_close();
version(Windows)
{
extern (C)  void	 disp_usebios();
}
extern (C)  void	 disp_move(int,int);
extern (C)  void	 disp_flush();
extern (C)  void	 disp_eeol();
extern (C)  void	 disp_eeop();
extern (C)  void	 disp_startstand();
extern (C)  void	 disp_endstand();
extern (C)  void	 disp_setattr(int);
extern (C)  void	 disp_setcursortype(int);
extern (C)  void	 disp_pokew(int,int,ushort);
extern (C)  void	 disp_scroll(int,uint,uint,uint,uint,uint);
extern (C)  void	 disp_setmode(byte);
extern (C)  void	 disp_peekbox(ushort *,uint,uint,uint,uint);
extern (C)  void	 disp_pokebox(ushort *,uint,uint,uint,uint);
version(Windows)
{
extern (C)  void	 disp_set43();
extern (C)  void	 disp_reset43();
}
extern (C)  void	 disp_fillbox(uint,uint,uint,uint,uint);
extern (C)  void	 disp_hidecursor();
extern (C)  void	 disp_showcursor();
extern (C)  ushort  disp_peekw(int,int);

/* Globals for IBM PC displays (read only):     */
extern (C)  byte
	 disp_mono,
	 disp_mode,
	 disp_inited,
	 disp_ega;
extern (C)  uint  disp_base;

version(UNIXorXENIX)
{
extern (C) byte	disp_scomode, disp_captured;
extern (C) int  disp_vt_number;
extern (C) char *disp_offset;
}
else
{
extern (C)  byte  disp_snowycga;
}

const int DISP_REVERSEVIDEO       =0x70;
const int DISP_NORMAL             =0x07;
const int DISP_UNDERLINE          =0x01;
const int DISP_NONDISPLAY         =0x00;

const int DISP_INTENSITY          =0x08;
const int DISP_BLINK              =0x80;

version(Win32)
{
const int DISP_CURSORBLOCK =       100;
const int DISP_CURSORHALF  =        50;
const int DISP_CURSORUL    =        20;
}
else
{
const int DISP_CURSORBLOCK =(disp_mono ? 0x000C : 0x0007);
const int DISP_CURSORHALF  =(disp_mono ? 0x060C : 0x0307);
const int DISP_CURSORUL    =(disp_mono ? 0x0B0C : 0x0707);
}

version(UNIXorXENIX)
{
	// nothing
}
else
{

struct disp_t
{
	align(1)
    uint numrows;
    uint numcols;
    uint cursorrow;
    uint cursorcol;
    byte mono;
    byte snowycga;
    byte mode;
    byte inited;
    byte ega;
    byte reserved[3];
    short nowrap;

    union _disp
    {
	ushort *base;
	struct _disp1
	{   uint offset;
	    ushort base;
	}
	_disp1 _disp1x;
    }
	_disp _dispx;
version(Win32)
{
   void *handle;
}
};

extern (C) disp_t  disp_state;

/*
#define disp_numrows    disp_state.numrows
#define disp_numcols    disp_state.numcols
#define disp_cursorrow  disp_state.cursorrow
#define disp_cursorcol  disp_state.cursorcol
#define disp_mono       disp_state.mono
#define disp_snowycga   disp_state.snowycga
#define disp_mode       disp_state.mode
#define disp_inited     disp_state.inited
#define disp_ega        disp_state.ega
#define disp_nowrap     disp_state.nowrap
#define disp_base       disp_state._dispx._disp1x.base
*/

}//not version(UNIXorXENIX)

